Code

git-fetch --update-head-ok typofix
[git.git] / git-checkout.sh
1 #!/bin/sh
3 USAGE='[-f] [-b <new_branch>] [-m] [<branch>] [<paths>...]'
4 SUBDIRECTORY_OK=Sometimes
5 . git-sh-setup
7 old_name=HEAD
8 old=$(git-rev-parse --verify $old_name 2>/dev/null)
9 new=
10 new_name=
11 force=
12 branch=
13 newbranch=
14 newbranch_log=
15 merge=
16 while [ "$#" != "0" ]; do
17     arg="$1"
18     shift
19     case "$arg" in
20         "-b")
21                 newbranch="$1"
22                 shift
23                 [ -z "$newbranch" ] &&
24                         die "git checkout: -b needs a branch name"
25                 [ -e "$GIT_DIR/refs/heads/$newbranch" ] &&
26                         die "git checkout: branch $newbranch already exists"
27                 git-check-ref-format "heads/$newbranch" ||
28                         die "git checkout: we do not like '$newbranch' as a branch name."
29                 ;;
30         "-l")
31                 newbranch_log=1
32                 ;;
33         "-f")
34                 force=1
35                 ;;
36         -m)
37                 merge=1
38                 ;;
39         --)
40                 break
41                 ;;
42         -*)
43                 usage
44                 ;;
45         *)
46                 if rev=$(git-rev-parse --verify "$arg^0" 2>/dev/null)
47                 then
48                         if [ -z "$rev" ]; then
49                                 echo "unknown flag $arg"
50                                 exit 1
51                         fi
52                         new="$rev"
53                         new_name="$arg^0"
54                         if [ -f "$GIT_DIR/refs/heads/$arg" ]; then
55                                 branch="$arg"
56                         fi
57                 elif rev=$(git-rev-parse --verify "$arg^{tree}" 2>/dev/null)
58                 then
59                         # checking out selected paths from a tree-ish.
60                         new="$rev"
61                         new_name="$arg^{tree}"
62                         branch=
63                 else
64                         new=
65                         new_name=
66                         branch=
67                         set x "$arg" "$@"
68                         shift
69                 fi
70                 case "$1" in
71                 --)
72                         shift ;;
73                 esac
74                 break
75                 ;;
76     esac
77 done
79 # The behaviour of the command with and without explicit path
80 # parameters is quite different.
81 #
82 # Without paths, we are checking out everything in the work tree,
83 # possibly switching branches.  This is the traditional behaviour.
84 #
85 # With paths, we are _never_ switching branch, but checking out
86 # the named paths from either index (when no rev is given),
87 # or the named tree-ish (when rev is given).
89 if test "$#" -ge 1
90 then
91         hint=
92         if test "$#" -eq 1
93         then
94                 hint="
95 Did you intend to checkout '$@' which can not be resolved as commit?"
96         fi
97         if test '' != "$newbranch$force$merge"
98         then
99                 die "git checkout: updating paths is incompatible with switching branches/forcing$hint"
100         fi
101         if test '' != "$new"
102         then
103                 # from a specific tree-ish; note that this is for
104                 # rescuing paths and is never meant to remove what
105                 # is not in the named tree-ish.
106                 git-ls-tree --full-name -r "$new" "$@" |
107                 git-update-index --index-info || exit $?
108         fi
109         git-checkout-index -f -u -- "$@"
110         exit $?
111 else
112         # Make sure we did not fall back on $arg^{tree} codepath
113         # since we are not checking out from an arbitrary tree-ish,
114         # but switching branches.
115         if test '' != "$new"
116         then
117                 git-rev-parse --verify "$new^{commit}" >/dev/null 2>&1 ||
118                 die "Cannot switch branch to a non-commit."
119         fi
120 fi
122 # We are switching branches and checking out trees, so
123 # we *NEED* to be at the toplevel.
124 cdup=$(git-rev-parse --show-cdup)
125 if test ! -z "$cdup"
126 then
127         cd "$cdup"
128 fi
130 [ -z "$new" ] && new=$old && new_name="$old_name"
132 # If we don't have an old branch that we're switching to,
133 # and we don't have a new branch name for the target we
134 # are switching to, then we'd better just be checking out
135 # what we already had
137 [ -z "$branch$newbranch" ] &&
138         [ "$new" != "$old" ] &&
139         die "git checkout: to checkout the requested commit you need to specify 
140               a name for a new branch which is created and switched to"
142 if [ "X$old" = X ]
143 then
144         echo "warning: You do not appear to currently be on a branch." >&2
145         echo "warning: Forcing checkout of $new_name." >&2
146         force=1
147 fi
149 if [ "$force" ]
150 then
151     git-read-tree --reset -u $new
152 else
153     git-update-index --refresh >/dev/null
154     merge_error=$(git-read-tree -m -u $old $new 2>&1) || (
155         case "$merge" in
156         '')
157                 echo >&2 "$merge_error"
158                 exit 1 ;;
159         esac
161         # Match the index to the working tree, and do a three-way.
162         git diff-files --name-only | git update-index --remove --stdin &&
163         work=`git write-tree` &&
164         git read-tree --reset -u $new &&
165         git read-tree -m -u --aggressive $old $new $work || exit
167         if result=`git write-tree 2>/dev/null`
168         then
169             echo >&2 "Trivially automerged."
170         else
171             git merge-index -o git-merge-one-file -a
172         fi
174         # Do not register the cleanly merged paths in the index yet.
175         # this is not a real merge before committing, but just carrying
176         # the working tree changes along.
177         unmerged=`git ls-files -u`
178         git read-tree --reset $new
179         case "$unmerged" in
180         '')     ;;
181         *)
182                 (
183                         z40=0000000000000000000000000000000000000000
184                         echo "$unmerged" |
185                         sed -e 's/^[0-7]* [0-9a-f]* /'"0 $z40 /"
186                         echo "$unmerged"
187                 ) | git update-index --index-info
188                 ;;
189         esac
190         exit 0
191     )
192     saved_err=$?
193     if test "$saved_err" = 0
194     then
195         test "$new" = "$old" || git diff-index --name-status "$new"
196     fi
197     (exit $saved_err)
198 fi
200
201 # Switch the HEAD pointer to the new branch if we
202 # checked out a branch head, and remove any potential
203 # old MERGE_HEAD's (subsequent commits will clearly not
204 # be based on them, since we re-set the index)
206 if [ "$?" -eq 0 ]; then
207         if [ "$newbranch" ]; then
208                 if [ "$newbranch_log" ]; then
209                         mkdir -p $(dirname "$GIT_DIR/logs/refs/heads/$newbranch")
210                         touch "$GIT_DIR/logs/refs/heads/$newbranch"
211                 fi
212                 git-update-ref -m "checkout: Created from $new_name" "refs/heads/$newbranch" $new || exit
213                 branch="$newbranch"
214         fi
215         [ "$branch" ] &&
216         GIT_DIR="$GIT_DIR" git-symbolic-ref HEAD "refs/heads/$branch"
217         rm -f "$GIT_DIR/MERGE_HEAD"
218 else
219         exit 1
220 fi